	;
	; 2x driver
	;
	org $1001-2
	dw $1001
	
	dw $100B,0
	db $9E,"4109",0,0,0
	
temp	= $D0	
dest	= $D2

time		= $0D49
max_raster	= time + 47
max_raster_chr	= time + 40
track_info	= $0E17
regs_info	= $0DC1
volume_info	= $0E82

	include "!playerv.asm"
	
Print16	macro addr
	lda #"$"
	jsr $FFD2
	lda #addr >> 8
	jsr $FB10
	lda #addr & 255
	jsr $FB10
	endm
	
start	jsr $FF4F
	db $93,$22,"PLUS 44",$22,$0D
	db "COMPOSED BY CSABO/LOD 2019",$0D,$0D,$0D,$0D
	db "PRESS ",$9A,"[RIGHT]",$90," TO FAST FORWARD",$0D,$0D,$0D
	;
	db "TIME   : 00:00 ( )",$0D
	db "RASTER :       ( )",$0D
	db "MUSIC  : "
	db 0
	
	Print16 music_beg    
	jsr $FF4F
	db " - ",0
	Print16 music_end

	jsr $FF4F
	db " ($2000)"
	db $0D
	db "FREQ 1 : ",$0D
	db "FREQ 2 : ",$0D
	db "VOLUME : ",$0D
	db "NOISE  : ",$0D,$0D
	;
	db "8:",$0D
	db "7:",$0D
	db "6:",$0D
	db "5:",$0D
	db "4:",$0D
	db "3:",$0D
	db "2:",$0D
	db "1:",$0D
	db "0:"
	db 0
	;
	; ---
	;
	sei
	sta $FF3F
	;
	lda #$00
	sta time+7
	sta max_raster
	;
	lda #$41
	sta $FF19
	lda #$51
	sta $FF15
	;
	jsr PLAYER_INIT
	;
	; ---
	;        
	ldy #$00
	ldx #$00
delay	inx
	bne delay
	iny
	bne delay
	;
d1	lda $FF1D
	cmp #$F8
	bne d1
	;
d2	lda $FF1D
	cmp #$10
	bne d2
	;
	; ---
	;
main	lda #$37
	cmp $FF1D
	bne *-3
	lda #$00
	cmp $FF1D
	bne *-3
	;
	dec $FF19
	;
	lda $FF1D
	sta r_start+1
	;
	jsr PLAYER
	;
	lda $FF1D
	sec
r_start	sbc #$00
	cmp max_raster
	bcc not_larger
	;
	sta max_raster
	;
	and #$0F    
	tax
	lda hex_char,x
	sta max_raster_chr+1
	;
	lda max_raster
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	sta max_raster_chr
	;
not_larger
	;
	inc $FF19
	jsr dump_volume
	;
sync2	lda $FF1D
	cmp #$C3
	bcs call2
	;
	lda #$BF
	sta $FD30
	sta $FF08
	lda $FF08
	and #$08
	bne sync2
	;
	inc $FF19			; fast forward
	jsr PLAYER_SOUND
	jsr PLAYER
	jsr inc_timer
	dec $FF19 
	jmp sync2
	;
call2	dec $FF19
	jsr PLAYER_SOUND
	inc $FF19
	;
	; ------------
	;
	inc $FF19
	inc $FF19
	jsr inc_timer
	jsr dump_volume
	jsr dump_registers
	dec $FF19
	dec $FF19
	jmp main
	
inc_timer
	lda time+7
	clc
	adc #$01
	cmp #50
	bne inc1     
	;
	ldx #$05
inc2	dex 
	cpx #$02
	beq inc2
	lda time,x
	clc
	adc #$01
	cmp time_end,x
	bne inc3
	lda #$30
inc3	sta time,x
	cmp #$30
	beq inc2
	;
	lda #$00
inc1	sta time+7
	;
	rts
time_end
	db $3A,$3A,$3A,$36,$3A
	
hex_char
	db "0123456789",1,2,3,4,5,6
	
dump_volume
	ldx #$00
dv1	lda volume_info+0*40+1,x
	sta volume_info+0*40+0,x
	lda volume_info+1*40+1,x
	sta volume_info+1*40+0,x
	lda volume_info+2*40+1,x
	sta volume_info+2*40+0,x
	lda volume_info+3*40+1,x
	sta volume_info+3*40+0,x
	lda volume_info+4*40+1,x
	sta volume_info+4*40+0,x
	lda volume_info+5*40+1,x
	sta volume_info+5*40+0,x
	lda volume_info+6*40+1,x
	sta volume_info+6*40+0,x
	lda volume_info+7*40+1,x
	sta volume_info+7*40+0,x
	lda volume_info+8*40+1,x
	sta volume_info+8*40+0,x
	inx
	cpx #$25
	bne dv1
	;
	lda #volume_info+$25 & 255
	sta vol_ptr+1
	lda #volume_info+$25 >> 8
	sta vol_ptr+2
	;
	ldx #$08
dv4	ldy #$2D
	stx dv2+1
	lda $FF11
	and #$0F
dv2	cmp #$00
	bne dv3
	;
	lda F1LO
	cmp #$FE
	bne dv5
	lda F2LO
	cmp #$FE
	bne dv5
	ldy #$3A
	db $2C
dv5	ldy #$51
dv3	tya
vol_ptr	sta $1000
	;
	lda vol_ptr+1
	clc
	adc #40
	sta vol_ptr+1
	lda vol_ptr+2
	adc #00
	sta vol_ptr+2
	;
	dex
	bpl dv4
	rts
	
dump_registers
	lda #(regs_info + 0*40 & 255)
	sta dest
	lda #(regs_info + 0*40 >> 8)
	sta dest+1
	;
	ldx $FF0E
	lda $FF12
	and #$03
	jsr write_word
	;
	lda #(regs_info + 1*40 & 255)
	sta dest
	lda #(regs_info + 1*40 >> 8)
	sta dest+1
	;
	ldx $FF0F
	lda $FF10
	and #$03
	jsr write_word
	;
	lda #(regs_info + 2*40 & 255)
	sta dest
	lda #(regs_info + 2*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$0F
	jsr write_byte
	;
	lda #(regs_info + 3*40 & 255)
	sta dest
	lda #(regs_info + 3*40 >> 8)
	sta dest+1
	;
	lda $FF11
	and #$40
	jsr write_byte
	;
;	ldx #$17
;ul1	lda $70,x
;	sta $0C50,x
;	dex
;	bpl ul1
	;
	rts	
	;
	; A,X = hex value to print (hi,lo)
	;
write_word
	stx x_sav2+1
	jsr write_byte
x_sav2	lda #$00
	;
	; A = hex value to print
	;
write_byte
	sty y_save+1
	pha
	lsr a
	lsr a
	lsr a
	lsr a
	tax
	lda hex_char,x
	ldy #$00
	sta (dest),y
	pla
	and #$0F
	tax
	lda hex_char,x
	iny
	sta (dest),y
	;
	lda #$02
	jsr add_dest
y_save	ldy #$00
	rts

add_dest_1
	lda #$01
add_dest
	clc
	adc dest
	sta dest
	bcc *+4
	inc dest+1
	rts
	
	;org $E000
	align 256
music_beg
	include "!player.asm"
	include "music.asm"
music_end
;eof