;
; LOD Player Version 2
;
F1LO	= $FF0E
F1HI	= $FF12
F2LO	= $FF0F
F2HI	= $FF10

PLAYER_INIT
	jmp _PLAYER_INIT
PLAYER
	jmp _PLAYER
PLAYER_SOUND
	jmp _PLAYER_SOUND

freqs	
	db $0F,$00,$48,$00,$7D,$00,$B0,$00,$DF,$00,$0C,$01,$36,$01,$5E,$01
	db $84,$01,$A8,$01,$C9,$01,$E9,$01,$07,$02,$23,$02,$3E,$02,$57,$02
	db $6F,$02,$86,$02,$9B,$02,$AF,$02,$C2,$02,$D3,$02,$E4,$02,$F4,$02
	db $03,$03,$11,$03,$1F,$03,$2B,$03,$37,$03,$42,$03,$4D,$03,$57,$03
	db $60,$03,$69,$03,$72,$03,$7A,$03,$81,$03,$88,$03,$8F,$03,$95,$03
	db $9B,$03,$A1,$03,$A6,$03,$AB,$03,$B0,$03,$B4,$03,$B8,$03,$BC,$03
	db $C0,$03,$C4,$03,$C7,$03,$CA,$03,$CD,$03,$D0,$03,$D2,$03,$D5,$03
	db $D7,$03,$DA,$03,$DC,$03,$DE,$03
	db $E0,$03,$E2,$03,$E4,$03,$E5,$03	; $70     1
	db $E7,$03,$E8,$03,$EA,$03,$EB,$03,$EC,$03,$ED,$03,$EE,$03,$FE,$03	; $80     1
	
; COMMAND BYTES

END_MARK	= $FF
INS		= $F0
VOL		= $E0
ARP		= $D0
LEN		= $50

; Constants
base_note = -5 ; shift to F0
C0	= base_note + 0
Ci0	= base_note + 1
D0	= base_note + 2
Di0	= base_note + 3
E0	= base_note + 4
F0	= base_note + 5
Fi0	= base_note + 6
G0	= base_note + 7
Gi0	= base_note + 8
A0	= base_note + 9
Ai0	= base_note + 10
B0	= base_note + 11

C1	= base_note + 12
Ci1	= base_note + 13
D1	= base_note + 14
Di1	= base_note + 15
E1	= base_note + 16
F1	= base_note + 17
Fi1	= base_note + 18
G1	= base_note + 19
Gi1	= base_note + 20
A1	= base_note + 21
Ai1	= base_note + 22
B1	= base_note + 23

C2	= base_note + 24
Ci2	= base_note + 25
D2	= base_note + 26
Di2	= base_note + 27
E2	= base_note + 28
F2	= base_note + 29
Fi2	= base_note + 30
G2	= base_note + 31
Gi2	= base_note + 32
A2	= base_note + 33
Ai2	= base_note + 34
B2	= base_note + 35

C3	= base_note + 36
Ci3	= base_note + 37
D3	= base_note + 38
Di3	= base_note + 39
E3	= base_note + 40
F3	= base_note + 41
Fi3	= base_note + 42
G3	= base_note + 43
Gi3	= base_note + 44
A3	= base_note + 45
Ai3	= base_note + 46
B3	= base_note + 47

C4	= base_note + 48
Ci4	= base_note + 49
D4	= base_note + 50
Di4	= base_note + 51
E4	= base_note + 52
F4	= base_note + 53
Fi4	= base_note + 54
G4	= base_note + 55
Gi4	= base_note + 56
A4	= base_note + 57
Ai4	= base_note + 58
B4	= base_note + 59

C5	= base_note + 60
Ci5	= base_note + 61
D5	= base_note + 62

OFF = 71

;-----

_PLAYER_INIT
	ldx #$FF
	stx VOLTAB_CNT
	inx
	stx NOTE1
	stx NOTE2
	inx
	stx NOTELEN1
	stx NOTELEN2
	;
	ldx #Channel1 & 255
	ldy #Channel1 >> 8
	jsr set_ch1
	;
	ldx #Channel2 & 255
	ldy #Channel2 >> 8
	jmp set_ch2

reset_ch1
	ldx #Channel1_repeat & 255 ;SPCH1
	ldy #Channel1_repeat >> 8 ;SPCH1 + 1
set_ch1	stx PCH1
	sty PCH1 + 1
	;
advance_ch1
	ldy #$01
	lda (PCH1),y	; HI byte
	beq reset_ch1
	sta CH1 + 1
	dey
	lda (PCH1),y	; LO byte
	sta CH1
	;
	lda PCH1
	clc
	adc #$02
	sta PCH1
	bcc *+4
	inc PCH1+1
	;
	rts
	
reset_ch2
	ldx #Channel2_repeat & 255 ;SPCH2
	ldy #Channel2_repeat >> 8 ; SPCH2 + 1
set_ch2	stx PCH2
	sty PCH2 + 1
	;
advance_ch2
	ldy #$01
	lda (PCH2),y
	beq reset_ch2
	sta CH2 + 1
	dey
	lda (PCH2),y
	sta CH2
	;
	lda PCH2
	clc
	adc #$02
	sta PCH2
	bcc *+4
	inc PCH2+1
	;
	rts

	;
	;##################
	;

_PLAYER
	;------------------
	inc NOTE1
	;INC ARP_CNT1
	;
	;JMP *
	;
	lda NOTE1
	cmp NOTELEN1
	beq next_note1
	jmp channel2
	;
new_pattern1
	jsr advance_ch1
	;
next_note1
	ldy #$00
	sty NOTE1		; reset note counter
	sty TICK1
	sty ARP_CNT1		; reset arp counter
	;
	lda (CH1),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern1
	;
	cmp #$FE
	bne *+8
	inc $FF19
	lda (CH1),y
	iny
	;	
	cmp #INS		; --- instrument change?
	bcc pl_10
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE1   	; store instrument type
	;
	lda (CH1),y		; get byte
	iny
	;
pl_10	cmp #VOL		; --- volume table change?
	bcc pl_11
	;
	and #$0F		; keep lower 4 bits
	asl a			; *2
	tax
	lda voltabs,x		; look up pointer from table
	sta VOL_TAB
	lda voltabs+1,x
	sta VOL_TAB+1
	;
	lda #$FF		; reset voltab counter
	sta VOLTAB_CNT
	;
	lda (CH1),y		; get byte
	iny
	;
pl_11	cmp #ARP		; --- arpeggio change?
	bcc pl_12
	;
	and #$0F
	asl a
	tax
	lda arps,x		; get arp lo byte
	sta arp_ptr1+1
	lda arps+1,x
	sta arp_ptr1+2
	;
	lda #$04
	sta INS_TYPE1
	;
	lda (CH1),y		; get byte
	iny
	;
pl_12	cmp #LEN		; --- set note length?
	bcc pl_13
	;
	sec
	sbc #LEN
	sta NOTELEN1
	;
	lda (CH1),y
	iny
	;
pl_13	; - store note!
	;
	sta TONE1
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH1
	sta CH1
	bcc noi_1
	inc CH1 + 1
noi_1	;
	;
	; -----------------------------------------------------------------
	;
channel2
	inc NOTE2
	;INC ARP_CNT2
	;
	lda NOTE2
	cmp NOTELEN2
	beq next_note2
	jmp pl_50
	;  
new_pattern2
	jsr advance_ch2
	;
next_note2
	ldy #$00
	sty NOTE2		; reset note counter
	sty TICK2
	sty ARP_CNT2		; reset arp counter
	;
	lda (CH2),y		; get byte
	iny
	;
	cmp #END_MARK		; $FF goes to new pattern
	beq new_pattern2
	;
	cmp #$FE
	bne *+8
	inc $FF19
	lda (CH2),y
	iny
	;
	cmp #INS		; --- instrument change?
	bcc pl_20
	;
	and #$0F		; keep lower 4 bits
	sta INS_TYPE2   	; store instrument type
	;
	lda (CH2),y		; get byte
	iny
	;
pl_20	cmp #VOL		; --- volume table change?
	bcc pl_21
	;
	and #$0F		; keep lower 4 bits
	asl a			; *2
	tax
	lda voltabs,x		; look up pointer from table
	sta VOL_TAB
	lda voltabs+1,x
	sta VOL_TAB+1
	;
	lda #$FF		; reset voltab counter
	sta VOLTAB_CNT
	;
	lda (CH2),y		; get byte
	iny
	;
pl_21	cmp #ARP		; --- arpeggio change?
	bcc pl_22
	;
	and #$0F
	asl a
	tax
	lda arps,x		; get arp lo byte
	sta arp_ptr2+1
	lda arps+1,x
	sta arp_ptr2+2
	;
	lda #$04
	sta INS_TYPE2
	;
	lda (CH2),y		; get byte
	iny
	;
pl_22	cmp #LEN		; --- set note length?
	bcc pl_23
	;
	sec
	sbc #LEN
	sta NOTELEN2
	;
	lda (CH2),y
	iny
	;
pl_23	; - store note!
	;
	sta TONE2
	;
	; --- advance pointer
	;
	tya
	clc
	adc CH2
	sta CH2
	bcc noi_2
	inc CH2 + 1
noi_2	;     
	;
	;    
pl_50
	;              
	;			; --- special: reset store counter
	;LDA #$00
	;STA store_cnt		
	;
	; --- SOUND PROCESSING
	;
_PLAYER_SOUND
	lda #$20		; assume no noise
	sta NOISE
	;
	ldy VOLTAB_CNT
	iny
	lda (VOL_TAB),y
	bpl noi_3		; check for $FF
	ldy #$00		; reached, so warp
noi_3	sty VOLTAB_CNT
	;
	inc ARP_CNT1
	inc ARP_CNT2
	;
	ldx #$00		; channel 0
	jsr sound
	;
	sta F1LO
	sty F1HI_x+1
	;
	lda F1HI
	and #$FC
F1HI_x	ora #$00
	sta F1HI
	;
	ldx #$01		; channel 1
	jsr sound
	;
	sta F2LO
	sty F2HI
	;
	; ---
	;    
	inc TICK1
	inc TICK2
	;
	; ---
	;
	lda F1LO
	cmp #$FE
	bne do_volume_set
	lda F2LO
	cmp #$FE
	beq skip_volume_set
	;
do_volume_set
	ldy VOLTAB_CNT
	lda (VOL_TAB),y		; nope, read from envelope
	ora #$10
	ora NOISE
	sta $FF11
	;     
skip_volume_set
	rts     
	;
inst_table
	dw normal		; $F0
	dw bassdrum		; $F1
	dw snare		; $F2
	dw add_hihat		; $F3
	dw arp			; $F4
	dw vib			; $F5
	dw snare2		; $F6
	;dw glide		;
	;dw noiser		;
	;dw add1		;

sound
	lda TONE1,x		; OFF means no further processing
	cmp #OFF
	beq normal
	; 
	lda INS_TYPE1,x
	asl a
	tay
	lda inst_table,y
	sta inst_jump+1
	lda inst_table+1,y
	sta inst_jump+2
	;
inst_jump
	jmp $0000
	;
	; ---
	;
add_hihat
	lda TICK1,x
	cmp #$02
	bcs off1
	asl a
	tax
	;
	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda hihat_freq,x
	ldy hihat_freq+1,x
	rts

off1	lda #OFF
	jmp lookup
	
arp_restart
	and #$0F		; low byte is new position
	sta ARP_CNT1,x
	;JMP arp			; again!
arp	
	lda TONE1,x		; extra feature: OFF "knows" not to use arp
	cmp #OFF
	beq lookup
	;   
	ldy ARP_CNT1,x		; load current arp counter
	;
	cpx #$00		; check which channel
	beq arp_ptr1
arp_ptr2
	lda $1000,y		; for channel 2 (self-mod)
	jmp arp_1
arp_ptr1
	lda $1000,y		; for channel 1 (self-mod)
arp_1
	bmi arp_restart		; check for negative numbers
	;
arp_add
	clc
	adc TONE1,x
	db $2C			; skip next 2 bytes
	;
	; ---
	;
normal	lda TONE1,x		; normal note
lookup	asl a
	tax
	lda freqs,x
	ldy freqs+1,x
	rts
	
;noiser	lda #$40		; turn on noise bit
;	sta NOISE
;	lda TONE1,x
;	ldy #$03
;	rts
	
;add1	lda TONE1,x		; normal note
;	asl a
;	tax
;	lda freqs,x
;	clc
;	adc #$01
;	ldy freqs+1,x
;	rts
	
;	;
;slider	;
;;	LDA slide
;;	BNE sl_01
;;	DEC slide+1
;;sl_01	DEC slide
;	;  
;	LDA TICK1,x
;	BNE add1
;	;
;	LDA slide
;	LDY slide+1
;	RTS
;	;
;add1	LDA TONE1,x
;	ASL a
;	TAX
;	LDY freqs+1,x
;	LDA freqs,x
;	CLC
;	ADC #$01
;	BCC sl_03
;	INY
;sl_03	RTS
	;                                 
	;TAX
	;LDA bass_freq,x
	;LDY bass_freq+1,x
	;RTS              
	
;vibX	lda NOTE1,x
;	and #$0F
;	tay
;	lda vibrato,y
;	bmi vib_sub1
;	bpl vib_add

vib	lda TICK1,x
	and #$0F
	tay
	lda vibrato,y
	bmi vib_sub1
	;
vib_add
	sta vib2+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	clc
vib2	adc #$01
	bcc *+3
	iny
	rts
	;
vib_sub1
	and #$7F
	;      
	sta vib4+1
	;
	lda TONE1,x
	asl a
	tax
	ldy freqs+1,x
	lda freqs,x
	sec
vib4	sbc #$01
	bcs *+3
	dey
	rts

;glide_2	JMP normal

;glide	lda TICK1,x
;	beq glide_1
;	;
;	;
;	;
;	cmp #$04			; change this to determine glide length
;	bcs normal
;	;
;	lda glide_add
;	bmi glide_sub
;	;
;	lda glide_freq_current
;	clc
;	adc glide_freq_diff
;	sta glide_freq_current
;	lda glide_freq_current+1
;	adc glide_freq_diff+1
;	sta glide_freq_current+1
;	lda glide_freq_current+2
;	adc glide_freq_diff+2
;	sta glide_freq_current+2
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;	;
;glide_sub
;	lda glide_freq_current
;	sec
;	sbc glide_freq_diff
;	sta glide_freq_current
;	lda glide_freq_current+1
;	sbc glide_freq_diff+1
;	sta glide_freq_current+1
;	lda glide_freq_current+2
;	sbc glide_freq_diff+2
;	sta glide_freq_current+2
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;	;
;	; first iteration
;	;
;glide_1	lda TONE1,x			; look up destination freq
;	asl a
;	tay
;	lda freqs,y
;	sta glide_freq_dest+1
;	lda freqs+1,y   
;	sta glide_freq_dest+2
;	;
;	lda TONE_PREV1,x		; look up previous freq
;	asl a
;	tay
;	lda freqs,y
;	sta glide_freq_current+1
;	lda freqs+1,y   
;	sta glide_freq_current+2
;	;
;	lda #$00             		; clear low bytes of 24 bit values
;	sta glide_freq_dest
;	sta glide_freq_current
;	sta glide_freq_diff
;	;
;	lda TONE1,x
;	cmp TONE_PREV1,x
;	bcc glide_down
;	;
;	; up
;	;
;	lda glide_freq_dest+1		; diff = dest - current
;	sec
;	sbc glide_freq_current+1
;	sta glide_freq_diff+1
;	lda glide_freq_dest+2
;	sbc glide_freq_current+2
;	sta glide_freq_diff+2
;	;
;	lda #$00
;gl_up	sta glide_add
;	;
;	lsr glide_freq_diff+2		; 24 bit div routine (1x player)
;	ror glide_freq_diff+1
;	ror glide_freq_diff		; div2 (2x player)
;	lsr glide_freq_diff+2
;	ror glide_freq_diff+1
;	ror glide_freq_diff		; div4 (4x player)
;	;lsr glide_freq_diff+2
;	;ror glide_freq_diff+1
;	;ror glide_freq_diff		; div8 (8x player)
;	;LSR glide_freq_diff+2
;	;ROR glide_freq_diff+1
;	;ROR glide_freq_diff
;	;
;	lda glide_freq_current+1
;	ldy glide_freq_current+2
;	;
;	rts
;
;glide_down
;	lda glide_freq_current+1	; diff = current - dest
;	sec
;	sbc glide_freq_dest+1
;	sta glide_freq_diff+1
;	lda glide_freq_current+2
;	sbc glide_freq_dest+2
;	sta glide_freq_diff+2
;	;
;	lda #$80     
;	bne gl_up			; always jump
	
snare2	lda #$40		; turn on noise bit
	sta NOISE
	;
	lda TICK1,x
	tax
	lda snare2_freq,x
	ldy #$03
	rts

snare	lda TONE1,x		; look up note freq
	asl a
	tay
	;
	lda TICK1,x
	tax  
	;
	lda snare_freq,x	; add snare freq
	clc
	adc freqs,y       	; add 8 bit value
	pha
	lda freqs+1,y
	adc #$00
	tay
	;   
	lda snare_noise,x	; turn on noise bit
	sta NOISE
	;
	pla
	rts
	
bassdrum
	lda TICK1,x
	tax
	;
	lda bass_freq_lo,x
	ldy bass_freq_hi,x
	rts
	
;	LDA TONE1,x		; look up note freq
;	ASL a
;	TAY
;	;
;	LDA TICK1,x
;	ASL a
;	ADC #bass_freq-snare_freq
;	TAX  
;	;
;	LDA snare_freq,x	; 16 bit add: add bass-drum freq
;	CLC
;	ADC freqs,y       
;	PHA
;	LDA snare_freq+1,x
;	ADC freqs+1,y
;	TAY
;	PLA
	rts

snare_noise
	db $20,$40
	db $40,$40
	db $40,$40
	
snare_freq
	db $10,$d4;,$b6,$b8
	db $ce,$c4;,$d0,$d8
	db $c2,$c1;,$ea,$ec
	;db $ee,$f0;,$f2,$f4
	;db $f6,$f8;,$fb,$fc
	;
	;db $f5,$f4;,$a0,$90
	;db $f4,$f3;,$90,$80
	;db $f3,$f2;,$80,$70
	;db $f2,$f1;,$70,$60
	;db $f1,$f0;,$60,$50
	
snare2_freq
	db $F1,$91
	db $E1,$51
	db $D1,$31
	db $D0,$41
	db $CD,$42
	db $CA,$43
	
hihat_freq
	dw $03E4
	dw $03E2
	dw $03D0
	dw $03C0

bass_freq_lo
	db $E5,$A3,$59,$06,$76,$07
bass_freq_hi
	db $01,$01,$01,$01,$00,$00
	
vibrato
	;db $00,$03,$05,$06,$07,$06,$05,$03
	;db $00,$83,$85,$86,$87,$86,$85,$83
	db $00,$01,$02,$03,$03,$03,$02,$01
	db $00,$81,$82,$83,$83,$83,$82,$81
;eof